
#pragma once

#include <systemc>
#include "configuration.h"
#include "utils.h"

#define DEF_LOGFILENAME "./out/report.log"

#define N_LOGFILENAME   "./out/noc_conn.log"
#define N_LOG           "TLM_NOC"

#define R_LOGFILENAME   "./out/noc_transactions.log"
#define R_LOG           "TLM_ROUTER"

#define NI_LOGFILENAME   "./out/ni.log"
#define NI_LOG           "TLM_NI"

#define NM_LOGFILENAME "./out/nm_conn.log"
#define NM_LOG "NetworkManager"

#define ASCII_RED       "31"
#define ASCII_GREEN     "32"
#define ASCII_YELLOW    "33"

const std::string str_dir[Direction::num_dirs] = {"local","east","west","north","south","up","down"};

/** 
 * Handles log messages (writes to console and log)
 *
 * @param report    report object with log information
 * @param actions   valid actions
 */
void report_handler(const sc_report& report, const sc_actions& actions);

/** 
 * Configure sc report handler filename and actions
 */
void setup_logger();

//void creds_log_info(std::string router_name, uint8_t link, uint8_t num_creds, bool is_ext);

/** 
 * Log to cout
 */
void cout_logger(std::string msg);
