#include "utils.h"
#include "configuration.h"
#include "ratatoskrUtils/utils/GlobalResources.h"
#include <fstream>

using namespace std;

void get_pos_distances(float distances[3], vector<float> gr_pos[3]){
    GlobalResources& globalResources = GlobalResources::getInstance();
    gr_pos[0] = globalResources.xPositions;
    gr_pos[1] = globalResources.yPositions;
    gr_pos[2] = globalResources.zPositions;
    distances[0] = min_element(gr_pos[0].begin(), gr_pos[0].end())[1];
    distances[1] = min_element(gr_pos[1].begin(), gr_pos[1].end())[1];
    distances[2] = min_element(gr_pos[2].begin(), gr_pos[2].end())[1];
}

void convert_pos_to_int(float pos_float[3], uint8_t pos_int[3]){
    float dists[3];
    vector<float> gr_pos[3];
    get_pos_distances(dists, gr_pos);

    pos_int[0] = round(pos_float[0]/dists[0]);
    pos_int[1] = round(pos_float[1]/dists[1]);
    pos_int[2] = round(pos_float[2]/dists[2]);
}

void get_max_pos(uint8_t max_pos[3]){
    float dists[3];
    vector<float> gr_pos[3];
    get_pos_distances(dists, gr_pos);

    max_pos[0] = 1+round(max_element(gr_pos[0].begin(), 
                                   gr_pos[0].end())[0]/dists[0]);
    max_pos[1] = 1+round(max_element(gr_pos[1].begin(), 
                                   gr_pos[1].end())[0]/dists[1]);
    max_pos[2] = 1+round(max_element(gr_pos[2].begin(), 
                                   gr_pos[2].end())[0]/dists[2]);
}